extern void __main(void);

extern char __DATA_ROM_START[];
extern char __DATA_RAM_START[];
extern char __DATA_RAM_END[];
extern char __DATA_RAM_SIZE[];
extern char __BSS_START[];
extern char __BSS_END[];
extern char __BSS_SIZE[];


extern unsigned int ramerror1;
extern unsigned int ramerror2;

void __init_main(void)
{

    char* endptr;						  
	char* srcptr;
	char* destptr;

#define RAMSTART	0x3FF000
#define RAMSIZE		0x5E00
#define RAMEND		0x3FF000 + RAMSIZE


	register ramcount;
	register r_ramerror1, r_ramerror2;


	//First check ram by writing 0x00 to each used byte

	r_ramerror1 = (unsigned short)0;
	r_ramerror2 = (unsigned short)0;
	ramcount = (unsigned short)0;

	while(ramcount <= RAMSIZE)
	{
		*(unsigned char*)(unsigned int)(RAMSTART + ramcount) = (unsigned char)0xFF;
		if(*(unsigned char*)(unsigned int)(RAMSTART + ramcount) != (unsigned char)0xFF) r_ramerror1++;
		
		*(unsigned char*)(unsigned int)(RAMSTART + ramcount) = (unsigned char)0x00;
		if(*(unsigned char*)(unsigned int)(RAMSTART + ramcount) != (unsigned char)0x00) r_ramerror2++;

		ramcount++;		

	}

	

	if(r_ramerror1 != 0 || r_ramerror2 != 0)
	{

		ramerror1 = (unsigned int)r_ramerror1;
		ramerror2 = (unsigned int)r_ramerror2;


	}

	ramerror1 = (unsigned int)r_ramerror1;
	ramerror2 = (unsigned int)r_ramerror2;


	srcptr = __DATA_ROM_START;
	destptr = __DATA_RAM_START;


	while(destptr < __DATA_RAM_END)
    {
		//copy rom data into ram
		*destptr = *srcptr;
		destptr++;
		srcptr++;
	}



/*
	srcptr = __BSS_START;
	
	while(srcptr <= __BSS_END)
	{
		*srcptr = (char)0x00;
		srcptr++;
	}

*/

	__main();

}		
		
