

/*
 * read  -- read bytes from the serial port. Ignore fd, since
 *          we only have stdin.                              
 */

#include "serial.h"

#define inbyte GetSByte

int
read (
       int fd,
       char *buf,
       int nbytes)
{
  int i = 0;

  for (i = 0; i < nbytes; i++) {
    *(buf + i) = inbyte();
    if ((*(buf + i) == '\n') || (*(buf + i) == '\r')) {
      i++;
      break;
    }
  }
  return (i);
}


