extern void main(void);

extern void InitCom(char portnum);
extern unsigned short ioport;

extern void puts2(char *sptr);
extern void itoa(unsigned long n, char *s);

//extern char on_rom();

unsigned int ramerror1;
unsigned int ramerror2;

void __main(void)
{
        unsigned long delaycount;
	char tempString[20];


	//insert any other special initialization routines here

	//activate fpu
        asm("mfmsr %r0");
        asm("ori  %r0,%r0,0x00002000");
        asm("mtmsr %r0");


	//brief delay to help serial hardware initialize (necessary?!)
        delaycount=0;
        do{
                delaycount++;
        }while(delaycount < 1000);

        InitCom(0);     // initialize SCI1 serial port 1
        InitCom(1);     // initialize SCI2 serial port 2
        ioport = 0;     // default to 0 for now, don't detect.

	puts2("\nBooted into main\n");

#if 0
	//__init_main performs a rudimentary RAM test for us; explode if failed
        if(on_rom() != 0 && (ramerror1 != 0 || ramerror2 != 0))
        {
                puts2("RAMERROR RAMERROR ");
                itoa(ramerror1, tempString);
                puts2(tempString);
                puts2(" ");
                itoa(ramerror2, tempString);
                puts2(tempString);
	        puts2(" bytes\n");
		//croak
                while(1);
        }
#endif

	//start real main
	main();
}


